"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .bulkjobstatus import BulkJobStatus
from datetime import datetime
import pydantic
from pydantic import model_serializer
from ttd_workflows.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from typing import List
from typing_extensions import Annotated, NotRequired, TypedDict


class GraphQlQueryJobTypedDict(TypedDict):
    r"""This is the response model that mirrors the GQL bulkjob"""

    id: int
    r"""The ID of the job."""
    created_at: datetime
    r"""Time of creation for that bulk job in UTC."""
    status: BulkJobStatus
    runtime_errors: Nullable[List[str]]
    r"""Errors encountered while executing the job"""
    completed_at: NotRequired[Nullable[datetime]]
    r"""The UTC data and time that the job completed."""
    completion_percentage: NotRequired[Nullable[float]]
    r"""The job completion percentage."""
    url: NotRequired[Nullable[str]]
    r"""The URL from which the job result can be downloaded."""
    raw_result: NotRequired[Nullable[str]]
    r"""The raw job result if the response is less than or equal to 20MB in size.
    If the job result is larger than 20MB, then null is returned.
    """
    query_gql_errors: NotRequired[Nullable[List[str]]]
    r"""If the GQL requests within the job hard failed (such as from an authorization error or an internal server error), the causes encountered during execution"""


class GraphQlQueryJob(BaseModel):
    r"""This is the response model that mirrors the GQL bulkjob"""

    id: int
    r"""The ID of the job."""

    created_at: Annotated[datetime, pydantic.Field(alias="createdAt")]
    r"""Time of creation for that bulk job in UTC."""

    status: BulkJobStatus

    runtime_errors: Annotated[
        Nullable[List[str]], pydantic.Field(alias="runtimeErrors")
    ]
    r"""Errors encountered while executing the job"""

    completed_at: Annotated[
        OptionalNullable[datetime], pydantic.Field(alias="completedAt")
    ] = UNSET
    r"""The UTC data and time that the job completed."""

    completion_percentage: Annotated[
        OptionalNullable[float], pydantic.Field(alias="completionPercentage")
    ] = UNSET
    r"""The job completion percentage."""

    url: OptionalNullable[str] = UNSET
    r"""The URL from which the job result can be downloaded."""

    raw_result: Annotated[OptionalNullable[str], pydantic.Field(alias="rawResult")] = (
        UNSET
    )
    r"""The raw job result if the response is less than or equal to 20MB in size.
    If the job result is larger than 20MB, then null is returned.
    """

    query_gql_errors: Annotated[
        OptionalNullable[List[str]], pydantic.Field(alias="queryGqlErrors")
    ] = UNSET
    r"""If the GQL requests within the job hard failed (such as from an authorization error or an internal server error), the causes encountered during execution"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "completedAt",
            "completionPercentage",
            "url",
            "rawResult",
            "queryGqlErrors",
        ]
        nullable_fields = [
            "completedAt",
            "completionPercentage",
            "url",
            "rawResult",
            "queryGqlErrors",
            "runtimeErrors",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
